#include "plugin_host.h"

#include "audio/mixer/channel_interface.h"

plugin_host::~plugin_host() {
    delete channel;
}

void plugin_host::try_open_editor() {
    if (!has_editor())
        return;
    if (editor_opened)
        return;
    // editor_window = g_window_manager.create_plugin_host_window(this);
    // open_editor(editor_window);
    editor_opened = true;
}

void plugin_host::try_close_editor() {
    if (!has_editor())
        return;
    if (editor_opened == false)
        return;
    close_editor();
    editor_opened = false;
    // g_window_manager.destroy_plugin_host_window(this);
}

void plugin_host::toggle_editor() {
    if (!has_editor())
        return;
    if (editor_opened)
        try_close_editor();
    else
        try_open_editor();
}

void plugin_host::init_channel_interface() {
    channel = new channel_interface(get_input_channels(), get_output_channels());
}
