#pragma once
#include "audio/plugin_host/plugin_host.h"
#include "misc/lib_load.h"
#include "pluginterfaces/vst2.x/aeffect.h"
#include "pluginterfaces/vst2.x/aeffectx.h"

class vst2_plugin_host : public plugin_host {
public:
    static VstTimeInfo vst_time_info;
    vst2_plugin_host();
    ~vst2_plugin_host() override;
    bool load_plugin(const char* path) override;

    void set_enabled(bool enabled) override;
    bool is_enabled() const override;

    void on_update_sample_rate(double sample_rate) override;
    void on_update_buffer_size(int buffer_size) override;
    [[nodiscard]] uint32_t get_input_channels() const override;
    [[nodiscard]] uint32_t get_output_channels() const override;
    void update_channel_node_name() override;

    void process(uint32_t frame_num) override;

    void idle_editor() override;
    [[nodiscard]] bool has_editor() const override;
    // [[nodiscard]] ImVec2 get_editor_size() const override;

    [[nodiscard]] std::string load_name() const override;
    [[nodiscard]] std::string load_vendor() const override;
protected:
    void open_editor() override;
    void close_editor() override;
private:
    VstIntPtr dispatch(VstInt32 opcode, VstInt32 index = 0, VstIntPtr value = 0, void* ptr = nullptr, float opt = 0) const;
    AEffect* effect_;
    std::shared_ptr<dynamic_library> library_;
    bool enabled_ = false;
};
